package top.ninwoo.cloudcenter.controller;

import org.springframework.web.bind.annotation.*;
import top.ninwoo.cloudcenter.service.CloudService;
import top.ninwoo.common.entity.NetworkTopology;
import top.ninwoo.common.entity.SeparatedClusterConfig;

import javax.annotation.Resource;
import java.util.List;

@RestController
@RequestMapping("/cluster")
public class ClusterController {

    @Resource
    CloudService cloudService;

    @RequestMapping(value = "/sendClusterConfigToEdgeNode", method = RequestMethod.POST)
    public List<SeparatedClusterConfig> sendClusterConfigToEdgeNode(@RequestBody List<SeparatedClusterConfig> clusterConfigs) {
        // return cloudService.sendClusterConfigToEdgeNode(clusterConfigs);
        return cloudService.sendClusterConfigToEdgeNodeByThreads(clusterConfigs);
    }

    @RequestMapping(value = "/removeClusterFromEdgeNode")
    public String removeClusterFromEdgeNode(Long clusterId) {
        boolean res = cloudService.deleteClusterFromEdgeNode(clusterId);
        if(res) {
            return "success";
        }
        return "fail";
    }

    @RequestMapping(value = "/getEdgeNodeIds")
    public List<String> getEdgeNodeIds() {
        return cloudService.getEdgeNodeIds();
    }

    @RequestMapping(value = "/adjustCluster", method = RequestMethod.POST)
    public Boolean adjustClusterToEdgeNode(@RequestBody List<SeparatedClusterConfig> clusterConfigs) {
        return cloudService.adjustCluster(clusterConfigs);
    }
}
